//
//  UpnpHttpServer.m
//  uPnp2
//
//  Created by rk on 2/04/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import "UpnpHttpServer.h"
#import <ifaddrs.h>
#import <netinet/in.h>
#import <sys/socket.h>


@implementation UpnpHttpServer

#pragma mark Properties
-(NSURL *)baseUrl {
    NSURL *result = nil;
    
    NSString *ipAddressString;
    	
	struct ifaddrs*	addrs;
	BOOL success = (getifaddrs(&addrs) == 0);
	if (success) 
	{
		const struct ifaddrs* cursor = addrs;
		while (cursor != NULL) 
		{
			NSMutableString* ip;
			if (cursor->ifa_addr->sa_family == AF_INET) 
			{
				const struct sockaddr_in* dlAddr = (const struct sockaddr_in*)cursor->ifa_addr;
				const uint8_t* base = (const uint8_t*)&dlAddr->sin_addr;
				ip = [[NSMutableString new] autorelease];
				for (int i = 0; i < 4; i++) 
				{
					if (i != 0) 
						[ip appendFormat:@"."];
					[ip appendFormat:@"%d", base[i]];
				}
                NSLog(@"ip: '%@'", ip);
                if (base[0] != 127) { // 127.0.0.1 == loopback
                    ipAddressString = ip;
                }
//				[result setObject:(NSString*)ip forKey:[NSString stringWithFormat:@"%s", cursor->ifa_name]];
			}
			cursor = cursor->ifa_next;
		}
		freeifaddrs(addrs);
	}
   
    if (ipAddressString) {
        NSString *urlString = [[NSString stringWithFormat:@"http://%@:%d", ipAddressString, port] autorelease];
        result = [[NSURL alloc]initWithString:urlString];        
    }
        
    return result;
}

@end
